{% extends theme('base.html') %}
{% import 'macro/fomanticui.html' as sui %}

{%- block title -%}
    {% if user.uid == edited_user.uid %}
        {%- trans %}My profile{% endtrans -%}
    {% else %}
        {%- trans %}User profile edition{% endtrans -%}
    {% endif %}
{%- endblock -%}

{% block script %}
    <script src="/static/js/confirm.js"></script>
    <script src="/static/js/profile.js"></script>
{% endblock %}

{% block submenu %}
    <nav class="ui bottom attached two item borderless menu">
        <a class="item" href="{{ url_for('account.profile_edition', username=edited_user.uid[0]) }}">
            <i class="id card icon"></i>
            {% trans %}Personal information{% endtrans %}
        </a>
        <a class="active item" href="{{ url_for('account.profile_settings', username=edited_user.uid[0]) }}">
            <i class="tools icon"></i>
            {% trans %}Account information{% endtrans %}
        </a>
    </nav>
{% endblock %}

{% macro render_field(field, noindicator=false) %}
    {% set lock_indicator = field.render_kw and ("readonly" in field.render_kw or "disabled" in field.render_kw) %}
    {% if edited_user.uid == user.uid or lock_indicator or noindicator %}
        {{ sui.render_field(field, **kwargs) }}
    {% elif field.name in edited_user.write %}
        {{ sui.render_field(field, **kwargs) }}
    {% elif field.name in edited_user.read %}
        {{ sui.render_field(field, indicator_icon="eye", indicator_text=_("This user cannot edit this field"), **kwargs) }}
    {% else %}
        {{ sui.render_field(field, indicator_icon="eye slash", indicator_text=_("This user cannot see this field"), **kwargs) }}
    {% endif %}
{% endmacro %}

{% block content %}
    {% if self_deletion or user.can_manage_users %}
        <div id="modal-delete" class="ui basic modal">
            <div class="ui icon header">
                <i class="user minus icon"></i>
                {% trans %}Account deletion{% endtrans %}
            </div>
            <div class="content">
                <p>
                    {% if user.uid != edited_user.uid %}
                        {{ _("Are you sure you want to delete this user? This action is unrevokable and all the data about this user will be removed.") }}
                    {% else %}
                        {{ _("Are you sure you want to delete your account? This action is unrevokable and all your data will be removed forever.") }}
                    {% endif %}
                </p>
            </div>
            <div class="actions">
                <div class="ui inverted cancel button">{% trans %}Cancel{% endtrans %}</div>
                <div class="ui inverted red approve button">{% trans %}Delete{% endtrans %}</div>
            </div>
        </div>
    {% endif %}

    <div class="ui clearing segment">
        <h2 class="ui center aligned header">
            <div class="content">
                {% trans %}Account information{% endtrans %}
            </div>
        </h2>

        <form method="POST"
              id="{{ form.__class__.__name__|lower }}"
              action="{{ request.url }}"
              role="form"
              enctype="multipart/form-data"
              class="ui form info{% if user.can_manage_users and not edited_user.has_password() %} warning{% endif %} profile-form"
        >

            {#{ render_field(form.csrf_token) }#}

            {% if "uid" in form %}
                {% block uid_field scoped %}{{ render_field(form.uid) }}{% endblock %}
            {% endif %}

            {% if "groups" in form %}
                {% block groups_field scoped %}{{ render_field(form.groups) }}{% endblock %}
            {% endif %}

            {% if "password1" in form %}
                {% block password_field scoped %}
                    <div class="two fields">
                        {{ render_field(form.password1, noindicator=true) }}
                        {{ render_field(form.password2, noindicator=true) }}
                    </div>
                {% endblock %}
            {% endif %}

            {% if user.can_manage_users %}

                {% if not edited_user.has_password() %}

                    <div class="ui message warning visible">
                        {% if has_smtp and edited_user.can_edit_self %}
                            <button type="submit" name="action" value="password-initialization-mail" class="ui right floated primary button">
                                {% trans %}Send email{% endtrans %}
                            </button>
                        {% endif %}
                        <div class="header">
                            {% trans %}This user does not have a password yet{% endtrans %}
                        </div>
                        {% if has_smtp and edited_user.can_edit_self %}
                            <p>{% trans %}You can solve this by:{% endtrans %}</p>
                            <ul class="ui list">
                                <li>{% trans %}setting a password using this form;{% endtrans %}</li>
                                <li>{% trans %}sending the user a password initialization mail, by clicking this button;{% endtrans %}</li>
                                <li>{% trans %}or simply waiting for the user to sign-in a first time, and then receive a password initialization mail.{% endtrans %}</li>
                            </ul>
                        {% else %}
                            <p>{% trans %}The user will not be able to authenticate unless the password is set{% endtrans %}</p>
                        {% endif %}
                    </div>

                {% elif has_smtp and edited_user.uid != user.uid and edited_user.has_password() and edited_user.can_edit_self %}

                    <div class="ui message info">
                        <button type="submit" name="action" value="password-reset-mail" class="ui right floated button">
                            {% trans %}Send mail{% endtrans %}
                        </button>
                        <div class="header">
                            {% trans %}Password reset{% endtrans %}
                        </div>
                        <p>{% trans %}If the user has forgotten his password, you can send him a password reset email by clicking this button.{% endtrans %}</p>
                    </div>

                {% endif %}

            {% endif %}

            <div class="ui right aligned container">
                <div class="ui stackable buttons">
                    {% if user.can_manage_users or self_deletion %}
                        <button type="submit" class="ui right floated basic negative button confirm" name="action" value="delete" id="delete">
                            {% if user.uid != edited_user.uid %}
                                {{ _("Delete the user") }}
                            {% else %}
                                {{ _("Delete my account") }}
                            {% endif %}
                        </button>
                    {% endif %}

                    {% if user.can_impersonate_users and user.uid != edited_user.uid %}
                        <a href="{{ url_for('account.impersonate', username=edited_user.uid[0]) }}" class="ui right floated basic button" name="action" value="impersonate" id="impersonate">
                            {{ _("Impersonate") }}
                        </a>
                    {% endif %}

                    <button type="submit" class="ui right floated primary button" name="action" value="edit" id="edit">
                        {{ _("Submit") }}
                    </button>

                </div>
            </div>
        </form>
    </div>
{% endblock %}
